/**********************************************************************
* JavaPhaser.java
* main applet
* mostly GUI setup
**********************************************************************/
import java.applet.Applet;
import java.awt.*;
import javax.swing.Timer;

public class JavaPhaser extends Applet {

  PhaseSpacePanel theDrawingPanel;
  
  public void init() {
    theDrawingPanel = new PhaseSpacePanel();
    TextUI phaseSpaceInterface = new TextUI(theDrawingPanel);
    CommandPanel theCommandPanel = new CommandPanel(phaseSpaceInterface);
    theCommandPanel.setupPanelComponents();
    GridBagLayout gbl = new GridBagLayout();
    GridBagConstraints gbc = new GridBagConstraints();

    setLayout(gbl);

    gbc.anchor = GridBagConstraints.NORTHWEST;
    gbc.fill = GridBagConstraints.BOTH;
    gbc.weighty = 1.0;
    gbc.weightx = 0.01;
    gbc.ipadx = 3;
    gbc.ipady = 3;
    gbc.gridwidth = GridBagConstraints.RELATIVE;
    gbl.setConstraints(theCommandPanel, gbc);

    gbc.weightx = 1.0;
    gbc.fill = GridBagConstraints.BOTH;
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbl.setConstraints(theDrawingPanel, gbc);

    add(theCommandPanel);
    add(theDrawingPanel);

    theDrawingPanel.repaint();

    theDrawingPanel.addMouseListener(theDrawingPanel);
    theDrawingPanel.addKeyListener(theDrawingPanel);
    
    AutomaticAdvancer theAdvancer = new AutomaticAdvancer(theDrawingPanel);
    try{
      //starting now, update every n ms, where n is second parameter
      Timer advanceTimer = new Timer(50, theAdvancer);
    }catch(IllegalArgumentException ee){
      System.out.println("You are a loser.  LOSER!");
    }
    catch(IllegalStateException ee){
      System.out.println("You are a certified nincompoop.");
    }
    
    phaseSpaceInterface.setAdvancer(theAdvancer);
      
}

  public void paint(Graphics g) {
    theDrawingPanel.repaint();
  }

  public static void main(String args[]) {
    Frame f = new Frame("JavaPhaser");
    JavaPhaser ex1 = new JavaPhaser();

    ex1.init();

    f.add("Center", ex1);
    f.pack();
    f.setSize(f.getPreferredSize());
    f.show();
  }
}
